# Web Scraper API features

Our all-in-one [Web Scraper API](https://oxylabs.io/products/scraper-api/web) includes a collection of built-in features designed to simplify, scale-up, and automate public data extraction workflows. Refer to the following list of features and visit their documentation pages for in-depth configuration steps.

### OxyCopilot <a href="#h_f3f6c361dc" id="h_f3f6c361dc"></a>

Develop web scrapers and parsers with an AI-powered feature, [OxyCopilot](https://developers.oxylabs.io/scraper-apis/oxycopilot-beta), via the Web Scraper API Playground by simply providing target URLs and writing your needs in plain English. To learn more about how OxyCopilot works and explore ready-to-use prompts, visit the [OxyCopilot prompts and code samples library](https://oxylabs.io/resources/prompts-code-samples) available on our website.

### Cloud integration <a href="#h_452d7a0bf5" id="h_452d7a0bf5"></a>

The [cloud integration](https://developers.oxylabs.io/scraper-apis/web-scraper-api/features/result-processing-and-storage/cloud-storage) feature enables you to automatically retrieve job results directly to your [Amazon S3](https://developers.oxylabs.io/scraper-apis/web-scraper-api/features/result-processing-and-storage/cloud-storage#amazon-s3), [Google Cloud Storage](https://developers.oxylabs.io/scraper-apis/web-scraper-api/features/result-processing-and-storage/cloud-storage#google-cloud-storage), [Alibaba OSS](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/features/result-processing-and-storage/cloud-storage#alibaba-cloud-object-storage-service-oss), or [other S3-compatible storage](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/features/result-processing-and-storage/cloud-storage#other-s3-compatible-storage). This way, you don’t have to make additional requests to get the data from us.

### Batch queries <a href="#h_53624261ce" id="h_53624261ce"></a>

For efficient scraping operations, Web Scraper API allows you to submit up to 5,000 `query` or `URL` parameters per batch. Head to our [documentation](https://developers.oxylabs.io/scraper-apis/web-scraper-api/integration-methods/push-pull#batch-query) to learn more.

### Custom Parser <a href="#h_e55447383b" id="h_e55447383b"></a>

When you want to parse the HTML of a web page, but there's no dedicated parser for the target, you can do so with [Custom Parser](https://developers.oxylabs.io/scraper-apis/web-scraper-api/features/result-processing-and-storage/custom-parser) by crafting your own parsing and data processing logic. You may also create, modify, and reuse [Parser Presets](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/features/result-processing-and-storage/custom-parser/parser-presets) by hosting them on our system. Self-healing makes the best use of our fast-adapting infrastructure and keeps your scraping operations working effectively as the target websites change.

### Scheduler <a href="#h_2ee27fadb9" id="h_2ee27fadb9"></a>

For automatic execution of recurring scraping and parsing jobs, you can leverage the [Scheduler](https://developers.oxylabs.io/scraper-apis/web-scraper-api/features/scheduler) feature to create schedules. We recommend using this feature together with cloud integration to retrieve data at specified intervals.

### Custom browser instructions

Set up [custom browser instructions](https://developers.oxylabs.io/scraper-apis/web-scraper-api/features/js-rendering-and-browser-control/browser-instructions) to [render JavaScript](https://developers.oxylabs.io/scraper-apis/web-scraper-api/features/js-rendering-and-browser-control/javascript-rendering) on web pages and execute browser actions like clicking, scrolling, and text input. Define them manually, via our step-by-step Playground interface, or let AI generate them from a plain English prompt.

### XHR request capturing

Sometimes it is more convenient to extract the required data from one or more of the Fetch/XHR requests that a browser makes while loading the web page, rather than parsing the HTML. [Fetch/XHR request capturing](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/features/result-processing-and-storage/output-types/capturing-network-requests-fetch-xhr) is a feature that lets you retrieve these requests as structured JSON data from dynamic content sources.

### Markdown output

This feature allows you to [request markdown output](https://developers.oxylabs.io/scraping-solutions/web-scraper-api/features/result-processing-and-storage/output-types/markdown-output) as an alternative option to HTML or parsed JSON results. These responses provide an easy-to-read format, simplifying result integration into various content workflows and AI tools. Markdown format is especially useful when working with LLMs due to its light weight and clear syntax.\
​

***

<a href="https://dashboard.oxylabs.io/en/" class="button primary">Head back to the dashboard</a>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.oxylabs.io/help-center/products-and-features/web-scraper-api-features.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
